package at.ac.uibk.gitsearch.service.gitlab_events;

import at.ac.uibk.gitsearch.service.gitlab_events.GitlabEventService.ExtUserProvidedMetadataDTO;
import com.fasterxml.jackson.core.JacksonException;
import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.dataformat.yaml.YAMLFactory;

public class MetaDatav04Parser implements MetaDataParser {

    protected ObjectMapper yamlMapper = new ObjectMapper(new YAMLFactory());

    protected ObjectMapper jsonMapper = new ObjectMapper(new JsonFactory());

    protected MetaDatav04Parser() {
        super();
        yamlMapper.findAndRegisterModules();
        jsonMapper.findAndRegisterModules();
    }

    @Override
    public ExtUserProvidedMetadataDTO parse(String content, FormatType type) throws JacksonException {
        ObjectMapper mapper = null;

        switch (type) {
            case YAML:
                mapper = yamlMapper;
                break;
            case JSON:
                mapper = jsonMapper;
                break;
            default:
                mapper = yamlMapper;
        }

        return mapper.readValue(content, ExtUserProvidedMetadataDTO.class);
    }
}
